PanelDlgProc	PROTO	STDCALL :DWORD, :DWORD, :DWORD, :DWORD

.code

PanelDlgProc	proc	uses ebx esi edi hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
LOCAL buffer[MAX_PATH]:BYTE
	mov		eax, uMsg
	.IF		eax==WM_INITDIALOG
		mov		ecx, hWnd
		invoke	GetDlgItem, hWnd, IDC_T10X
		.IF		eax
			invoke	SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
		.ENDIF
		invoke	GetDlgItem, hWnd, IDC_RESULTLIST
		.IF		eax
			invoke	SendMessage, eax, LB_SETTABSTOPS, 1, addr lbTabStops
		.ENDIF
	.ELSEIF eax==WM_COMMAND
		mov		eax, wParam
		mov		ecx, wParam
		shr		eax, 16
		and		ecx, 0FFFFh
		.IF eax==LBN_SELCHANGE
			.IF	ecx==IDC_TRAINFILES
				.IF	hCurTDATFile
					invoke CloseHandle, hCurTDATFile
				.ENDIF
				mov hCurTDATFile, 0
				
				lea		ebx, buffer
				invoke	GetAppPath, ebx
				invoke	lstrcat, ebx, addr trainDir
				invoke	StrLen, ebx
				add		ebx, eax
				
				invoke	SendMessage, lParam, LB_GETCURSEL, 0, 0
				.IF		eax!=LB_ERR
					invoke	SendMessage, lParam, LB_GETTEXT, eax, ebx
					.IF		eax!=LB_ERR
						invoke	CreateFile, addr buffer, GENERIC_READ or GENERIC_WRITE,\
									FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL
						.IF		eax==INVALID_HANDLE_VALUE
							invoke	MessageBox, NULL, addr errOpenTrainFile, addr AppName, MB_ICONERROR
						.ELSE
							mov		hCurTDATFile, eax
							invoke 	LoadTDATFromFile
							push	curPoint
							invoke	RestoreTrainedDrawing
							pop		curPoint

							invoke	Resample, pBigBitmap, pSmallBitmap,\
					 			RESAMPLE_SMALL_WIDTH*2, RESAMPLE_SMALL_HEIGHT*2
							invoke	Resample, pBGraphBmp, pSGraphBmp, \
								GRAPH_SMALL_WIDTH*2, GRAPH_SMALL_HEIGHT*2
							invoke	GetParent, hWnd
							invoke	InvalidateRect, eax, NULL, FALSE	
						.ENDIF
					.ENDIF
				.ENDIF
			.ENDIF
		.ELSEIF eax==BN_CLICKED
			.IF	ecx==IDC_BTNTRAIN
				invoke IsDlgButtonChecked, hWnd, IDC_T1X
				.IF		eax==BST_CHECKED
					mov	 ebx, 1
				.ENDIF
				invoke	IsDlgButtonChecked, hWnd, IDC_T10X
				.IF		eax==BST_CHECKED
					mov	 ebx, 100
				.ENDIF
				invoke	IsDlgButtonChecked, hWnd, IDC_T100X
				.IF		eax==BST_CHECKED
					mov	 ebx, 100
				.ENDIF
				invoke	DoTrain, ebx
			.ELSEIF ecx==IDC_LOADMEM
				invoke	LoadBrainFromFile, hWnd
			.ELSEIF ecx==IDC_SAVEMEM
				invoke	SaveBrainToFile, hWnd
			.ELSEIF ecx==IDC_BRAINWASH
				invoke	BrainWash, hWnd
			.ENDIF
			
		.ENDIF
	.ELSEIF eax==WM_CTLCOLORSTATIC || eax==WM_CTLCOLORDLG
		invoke	GetStockObject, WHITE_BRUSH
		ret
	.ELSE
		xor		eax, eax
		ret
	.ENDIF
	xor	eax, eax
	inc	eax
ret
PanelDlgProc	endp